from temu.c.memory.memory import *
from temu.c.support.memory import *
from temu.c.support.objsys import *
from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.3')

SparcAsrHandler = CFUNCTYPE(None, c_void_p, c_uint32)

SparcAsiHandler = CFUNCTYPE(None, c_void_p, POINTER(MemTransaction))


class SparcV8Iface(Structure):
  pass
SparcV8Iface._fields_ = [ 
    ('getWindowCount', CFUNCTYPE(c_uint, c_void_p)),
    ('getWindowedReg', CFUNCTYPE(c_uint32, c_void_p, c_int, c_uint)),
    ('setWindowedReg', CFUNCTYPE(None, c_void_p, c_int, c_uint, c_uint32)),
    ('setAsiHandler', CFUNCTYPE(None, c_void_p, c_uint, c_int, CFUNCTYPE(None, c_void_p, POINTER(MemTransaction)))),
    ('getAsr', CFUNCTYPE(c_uint32, c_void_p, c_uint)),
    ('setAsr', CFUNCTYPE(None, c_void_p, c_uint, c_uint32)),
    ('setAsrReadHandler', CFUNCTYPE(None, c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32))),
    ('setAsrWriteHandler', CFUNCTYPE(None, c_void_p, c_uint, CFUNCTYPE(None, c_void_p, c_uint32))),
    ('getPsr', CFUNCTYPE(c_uint32, c_void_p)),
    ('setPsr', CFUNCTYPE(None, c_void_p, c_uint32)),
    ('getTbr', CFUNCTYPE(c_uint32, c_void_p)),
    ('setTbr', CFUNCTYPE(None, c_void_p, c_uint32)),
    ('getWim', CFUNCTYPE(c_uint32, c_void_p)),
    ('setWim', CFUNCTYPE(None, c_void_p, c_uint32)),
    ('getNPc', CFUNCTYPE(c_uint32, c_void_p)),
    ('setNPc', CFUNCTYPE(None, c_void_p, c_uint32)),
    ('getFsr', CFUNCTYPE(c_uint32, c_void_p)),
    ('setFsr', CFUNCTYPE(None, c_void_p, c_uint32)),
    ('getCsr', CFUNCTYPE(c_uint32, c_void_p)),
    ('setCsr', CFUNCTYPE(None, c_void_p, c_uint32))  ]


class SparcV8IfaceRef(Structure):
  pass
SparcV8IfaceRef._fields_ = [ 
    ('Obj', POINTER(Object)),
    ('Iface', POINTER(SparcV8Iface))  ]

class SparcV8IfaceRefArray(Structure):
  pass
SparcV8IfaceRefArray._fields_ = [ 
    ('Size', c_uint32),
    ('Reserved', c_uint32),
    ('Ifaces', POINTER(SparcV8IfaceRef))  ]
